/**
 ** KCAD: Kontrol-Alt-Delete
 ** Copyright (c) 2001, Flaming Sword Productions
 ** Released into the Public Domain
 **
 ** This twisted screensaver will allow you to trick your boss
 ** into thinking you're really running Windoze NT on your 
 ** desktop/server, instead of (insert UNIX OS name here).  This
 ** is for all of you out there with pathetic NAZI bosses.  BOFH
 ** all the way!
 **
 ** Brian C. Ledbetter <brian@shadowcom.net>
 ** http://www.shadowcom.net/Software/kss/kcad/
 **
 ** $Id: kcad.cpp,v 1.10 2002/01/07 18:31:20 brian Exp $
 **/
#include	<iostream>
#include	<stdlib.h>
#include	<qapplication.h>
#include	<qcombobox.h>
#include	<qdialog.h>
#include	<qpushbutton.h>
#include	<qpainter.h>
#include	<qlayout.h>
#include	<qlabel.h>
#include	<qimage.h>
#include	<qtimer.h>
#include	<qcolor.h>
#include	<qlabel.h>
#include	<kaccel.h>
#include	<kglobal.h>
#include	<kglobalsettings.h>
#include	<kbuttonbox.h>
#include	<klocale.h>
#include	<kconfig.h>
#include	<kapp.h>
#include	<kdialog.h>
#include	"kcad.h"

/**
 ** These are the graphics associated with this screensaver.  I
 ** prefer to compile them in, to simplify the installation/distribution
 ** of this screensaver...  C'est la vie, or something?
 **/
#include	"kcad.xpm"
#include	"kcad_kdelike.xpm"
#include	"kcad_hand.xpm"
#include	"kcad_hand_blank.xpm"
#include	"kcad_keys.xpm"
#include	"kcad_small.xpm"
#include	"kcad_windows2000.xpm"
#include	"kcad_windows2000_small.xpm"
#include	"kcad_windowsxp.xpm"
#include	"kcad_windowsxp_small.xpm"
#include	"kcad_dotnet.xpm"
#include	"kcad_dotnet_small.xpm"
#include	"kcad_winnt351.xpm"

/**
 ** General fine-tuning parameters.  Keeps me from being
 ** bored...
 **/
#define		ANIMATION_DELAY		5000
#define		ANIMATION_STEP		150
#define		ANIMATION_MOVE		5

#define		MODE_KDE		0
#define		MODE_WINDOWS_NT_40	1
#define		MODE_WINDOWS_2000	2
#define		MODE_WINDOWS_XP		3
#define		MODE_WINDOWS_DOTNET	4
#define		MODE_WINDOWS_NT_351	351

extern "C" {
	const char *kss_applicationName = "kcad.kss";
	const char *kss_description = I18N_NOOP("KCAD: Kontrol-Alt-Delete");
	const char *kss_version = "1.1";

	KScreenSaver *kss_create( WId id ) {
		KLocale::setMainCatalogue("klock");
		return new KCadSaver( id );
	}
	QDialog *kss_setup() {
		return new KCadSaverConfig();
	}

};

/**
 ** KCadSaver::KCadSaver(): Construct our illustrious screensaver.
 **/
		KCadSaver::KCadSaver( WId id )
		:KScreenSaver( id ) {

	oVisualMode = 0;
	handStep = 0;
	handDir = 1;

	readSettings();
	initialize();

	srand(Swidth);

	connect( &timer, SIGNAL(timeout()), SLOT(slotMoveWin()));
	QTimer::singleShot( 10, this, SLOT(blank()));
	QTimer::singleShot( 30, this, SLOT(slotDrawWin()));
	QTimer::singleShot( 30+ANIMATION_DELAY, this, SLOT(slotMoveHand()));

	timer.start( 7000 );
}

/**
 ** KCadSaver::~KCadSaver(): NOOO!  Don't destroy me!! :)
 **/
		KCadSaver::~KCadSaver() {

	timer.stop();
	QColor::leaveAllocContext();
	QColor::destroyAllocContext( colorContext );
}

/**
 ** KCadSaver::readSettings(): Load this user's settings.
 **/
void		KCadSaver::readSettings() {
KConfig		*config = KGlobal::config();

	config->setGroup("Settings");
	oVisualMode = config->readNumEntry( "NtLike", MODE_KDE );
}

/**
 ** KCadSaver::setMode(): Adjust the screensaver's view.
 **/
void		KCadSaver::setMode( int i ) {

	oVisualMode = i;
	initialize();
//	emit slotMoveWin(); // (see if this helps prevent lockups...)
}

/**
 ** KCadSaver::initialize(): Initialize the screensaver.  Build our
 ** KCadWindow.
 **/
void		KCadSaver::initialize() {

	colorContext = QColor::enterAllocContext();

	Swidth = width();
	Sheight = height();
	xpos = ypos = 10;

	hand = QImage( kcad_hand_xpm );
	hand_blank = QImage( kcad_hand_blank_xpm );
	keys = QImage( kcad_keys_xpm );

	/**
	 ** Basically, if the SCREEN WIDTH is less than 600,
	 ** we're going to assume that we're running in "small"
	 ** (ahem, "preview") mode.  Thus, we should behave like
	 ** this screensaver does in NT...  Just for kicks and
	 ** grins, of course.
	 **
	 ** My condolences to those of you who have screen resolutions
	 ** smaller than 600.  (mental note, maybe do this only if 
	 ** Swidth < window.width()?)
	 **/
	if( Swidth < 600 ) {

		handDir = 0;
		switch( oVisualMode ) {
			case(MODE_WINDOWS_DOTNET): window = QImage( kcad_dotnet_small_xpm ); break;
			case(MODE_WINDOWS_XP): window = QImage( kcad_windowsxp_small_xpm ); break;
			case(MODE_WINDOWS_2000): window = QImage( kcad_windows2000_small_xpm ); break;
			default: window = QImage( kcad_small_xpm ); break;
		}

	/**
	 ** ... Otherwise, this is a full-size window.
	 **/
	} else {

		/**
		 ** Based on our visual mode, we will adjust our appearance
		 ** slightly.
		 **/
		switch( oVisualMode ) {

			/**
			 ** NEW: Windoze .NET emulator.
			 **/
			case(MODE_WINDOWS_DOTNET):
				window = QImage( kcad_dotnet_xpm );
				handDir = 0;
			break;	

			/**
			 ** NEW: Windoze XP emulator.
			 **/
			case(MODE_WINDOWS_XP):
				window = QImage( kcad_windowsxp_xpm );
				handDir = 0;
			break;	

			/**
			 ** NEW: Windoze 2000 emulator.
			 **/
			case(MODE_WINDOWS_2000):
				window = QImage( kcad_windows2000_xpm );
				handDir = 0;
			break;	

			/**
			 ** NEW: The Last Working Version Of Windows (tm) NT (R).
			 **/
			case(MODE_WINDOWS_NT_351):
				window = QImage( kcad_winnt351_xpm );
				handDir = 0;
			break;

			/**
			 ** Super-secret (or not) Windoze NT emulator.
			 **/
			case(MODE_WINDOWS_NT_40):
				/**
				 ** (these values should be changed if the XPM changes.)
				 **/
				handOfsX = 29; handOfsY = 31; keysOfsX = 62; keysOfsY = 79;
				window = QImage( kcad_xpm );

				{ /** DIRTY HACK: Workaround C's limititation on declarations
				   ** inside of switch() groups...   Don't try THIS at home! **/
				QPalette stdpalette = palette();  
				QColor bgc = stdpalette.color( QPalette::Active, QColorGroup::Background );
				QColor tbbg = KGlobalSettings::activeTitleColor();
				for(int i=0; i<window.numColors(); i++) {
					QColor clr = window.color( i );

					/**
					 ** Replace the window background color.
					 **/
					if(clr == QColor( 0xff, 0xc0, 0xc0 )) {
					window.setColor( i, bgc.rgb() );

					/**
					 ** Replace the titlebar background color.
					 **/
					} else if(clr == QColor( 0x00, 0x00, 0x80 )) {
						window.setColor( i, tbbg.rgb() );
					}
				}

				/**
				 ** Do the same thing with hand_blank.
				 **/
				for(int i=0; i<hand_blank.numColors(); i++) {
					QColor clr = hand_blank.color( i );
					if(clr == QColor( 0xc0, 0xc0, 0xc0 )) {
						hand_blank.setColor( i, bgc.rgb() );
					}
				}
				}
			break;

			/**
			 ** DEFAULT: Draw the screensaver with a KDE-like widget.
			 **/
			case( MODE_KDE ):
			default:

				/**
				 ** (these values should be changed if the XPM changes.)
				 **/
				handOfsX = 34; handOfsY = 37; keysOfsX = 67; keysOfsY = 85;
				window = QImage( kcad_kdelike_xpm );
			break;
		}
	}
}

/**
 ** KCadSaver::slotMoveWin(): Move our KCadWindow.
 **/
void		KCadSaver::slotMoveWin() {

	emit blank();
	QTimer::singleShot( 5, this, SLOT(slotDrawWin()));

	/**
	 ** Don't bother moving the hand in the Mini-Saver.
	 **/
	if( handDir ) {
		QTimer::singleShot( ANIMATION_DELAY, this, SLOT(slotMoveHand()));
	}

	xpos = randX();
	ypos = randY();
}

/**
 ** KCadSaver::slotDrawWin(): Physically draw the window on
 ** the screen using a QPainter.
 **/
void		KCadSaver::slotDrawWin() {

	QPainter p( this );
	p.drawImage( xpos, ypos, window );
}

/**
 ** KCadSaver::slotDrawHand(): Physically draw the hand on
 ** the screen using a QPainter.
 **/
void		KCadSaver::slotDrawHand( int handStep ) {

	if( !handDir ) return;
	QPainter p( this );
	p.drawImage( xpos+handOfsX+handStep, ypos+handOfsY+handStep, hand );
}

/**
 ** KCadSaver::slotUndrawHand(): Cover the previous hand's
 ** image over with our background color. (erase it)
 **/
void		KCadSaver::slotUndrawHand( int handStep ) {

	if( !handDir ) return;
	QPainter p( this );
	p.drawImage( xpos+handOfsX+handStep, ypos+handOfsY+handStep, hand_blank );
	p.drawImage( xpos+keysOfsX, ypos+keysOfsY, keys );
}

/**
 ** KCadSaver::slotMoveHand(): This provides the transfixing
 ** icon animation present in the original Microsoft version
 ** of this screensaver.  Boy, I feel more secure, already!
 **/
void		KCadSaver::slotMoveHand() {

	/**
	 ** New: ONLY draw this if we're supposed to.  Otherwise, DON'T.
	 **/
	if( !handDir ) return;

	emit slotUndrawHand( handStep );

	handStep += ( handDir * ANIMATION_MOVE );

	if(handStep >= (ANIMATION_MOVE*2)) {
		handDir = -1*handDir;
	}

	emit slotDrawHand( handStep );

	if( handStep > 0 ) {
		QTimer::singleShot( ANIMATION_STEP, this, SLOT(slotMoveHand()));

	} else {
		handStep = 0;
		handDir = -1 * handDir;
	}
}

/**
 ** KCadSaver::blank(): Clear the screen.  This is used initially
 ** and is used whenever we move the window.  (Perhaps there's a
 ** better way to blank the window... I'll implement it before
 ** too long..)
 **/
void		KCadSaver::blank() {

	setBackgroundColor(black);
	erase();
}

/**
 ** KCadSaver::randX(): Generate a random WIDTH position.
 **/
int		KCadSaver::randX() {
unsigned int	x;

	do {
		x = int(rand());
	} while( (x > Swidth - window.width()) );
	return(x);
}

/**
 ** KCadSaver::randY(): Generate a random HEIGHT position.
 **/
int		KCadSaver::randY() {
unsigned int	y;

	do {
		y = int(rand());
	} while( (y > Sheight - window.height()) );
	return(y);
}

/********************************************************************
 ** KCadSaverConfig::KCadSaverConfig(): Build and present a 
 ** configuration dialog to the user.
 **/
		KCadSaverConfig::KCadSaverConfig( QWidget *parent, const char *name )
		:QDialog( parent, name, TRUE ), b(false) {

	saverView = 0;
	kcadSaver = 0L;

	setCaption(i18n("KCAD (Kontrol-Alt-Delete) Settings"));
	readSettings();

	QVBoxLayout *vbox = new QVBoxLayout( this, KDialog::marginHint(), KDialog::spacingHint() );
	QHBoxLayout *hbox = new QHBoxLayout( this, KDialog::marginHint(), KDialog::spacingHint() );
	vbox->addLayout( hbox );
	QHBoxLayout *localHbox = new QHBoxLayout;
	hbox->addLayout( localHbox );

	QLabel *lbl = new QLabel(i18n("View Mode:"), this );
	localHbox->addWidget( lbl );
	view = new QComboBox( false, this );
	view->insertItem( i18n("KDE Login") );
	if( saverView == MODE_WINDOWS_NT_351 ) { view->insertItem( i18n("Windows NT 3.51 Login") );b=true;}
	view->insertItem( i18n("Windows NT 4.0 Login") );
	view->insertItem( i18n("Windows 2000 Login") );
	view->insertItem( i18n("Windows XP Login") );
	view->insertItem( i18n("Windows .NET Login") );
	if(saverView != MODE_WINDOWS_NT_351 ) view->setCurrentItem( saverView );
	else view->setCurrentItem( 1 );
	localHbox->addWidget( view );

	QWidget *preview = new QWidget( this );
	preview->setFixedSize( 151, 115 );
	preview->show();

	kcadSaver = new KCadSaver( preview->winId() );
	hbox->addWidget( preview );

	QPushButton *button;
	KButtonBox *bbox = new KButtonBox( this );
	button = bbox->addButton( i18n("&Ok") );
	connect( button, SIGNAL( clicked() ), SLOT( slotOkPressed() ) );
	button = bbox->addButton( i18n("&Cancel") );
	connect( button, SIGNAL( clicked() ), SLOT( reject() ) );
	vbox->addWidget( bbox );

	if(!b) { KAccel *a = new KAccel( this );a->insertItem( i18n("a"),"a","Ctrl-Alt-W" );a->connectItem("a",this,SLOT(x()));a->readSettings(); }

	setView( saverView );
	connect( view, SIGNAL(activated(int)), this, SLOT(setView(int)));
}

/**
 ** KCadSaverConfig::~KCadSaverConfig(): DESTRUCTOR.  Delete persistent objects.
 **/
		KCadSaverConfig::~KCadSaverConfig() {

	if( kcadSaver ) delete kcadSaver;
}

/**
 ** KCadSaverConfig::readSettings(): Load our configuration.
 **/
void		KCadSaverConfig::readSettings() {
KConfig		*config = KGlobal::config();

	config->setGroup("Settings");
	saverView = config->readNumEntry( "NtLike", MODE_KDE );
}

/**
 ** KCadSaverConfig::setView(): Adjust our view.
 **/
void		KCadSaverConfig::setView( int i ) {

	if( b && (saverView > 1) ) saverView = i-1;
	else if( b && (saverView == 1) ) saverView = 351;
	else saverView = i;

	// update preview!
//	kcadSaver->setMode( saverView ); // (disabled.  kills the program badly.)
}

void KCadSaverConfig::x() { if(b) return; view->insertItem(i18n("Windows NT 3.51 Login"), 1); b=true; }

/**
 ** KCadSaverConfig::slotOkPressed(): 
 **/
void		KCadSaverConfig::slotOkPressed() {
KConfig		*config = KGlobal::config();

	config->setGroup("Settings");
	config->writeEntry("NtLike", saverView );
	config->sync();
	accept();
}
