/**
 ** KCAD: Kontrol-Alt-Delete
 ** Copyright (c) 2001, Flaming Sword Productions
 ** Released into the Public Domain
 **
 ** Written by Brian C. Ledbetter <brian@shadowcom.net>
 ** http://www.shadowcom.net/Software/kss/kcad/
 **/
#ifndef		__KCAD_H__
#define		__KCAD_H__
#include	<qdialog.h>
#include	<qtimer.h>
#include	<qvbox.h>
#include	<qpixmap.h>
#include	<qimage.h>
#include	<kscreensaver.h>

/**
 ** class KCadSaver: Main screensaver handler.
 **/
class		KCadSaver: public KScreenSaver {
Q_OBJECT

public:

		KCadSaver( WId );
		~KCadSaver();
	void		setMode( int i );

protected slots:
	void		slotMoveWin();
	void		slotDrawWin();
	void		slotMoveHand();
	void		slotDrawHand( int );
	void		slotUndrawHand( int );
	void		blank();

private:
	void		readSettings();
	void		initialize();
	int		randX();
	int		randY();

protected:
	QTimer		timer;
	int		xpos, ypos;
	unsigned int	Swidth, Sheight;
	int		colorContext;
	QImage		window, hand, hand_blank, keys;
			/**
			 ** Replaces oKdeLike.
			 ** 0 = KDE-like.
			 ** 1 = Windows NT 4.0-like
			 ** 2 = Windows 2000-like
			 ** 3 = Windows XP-like
			 **/
	int		oVisualMode;
	int		handStep, handDir, 
			handOfsX, handOfsY, 
			keysOfsX, keysOfsY;
};

/**
 ** class KCadSaverConfig: Present a configuration dialog to the
 ** user.  This screensaver now has enough features to need this!
 ** Woo hoo!
 **/
class		QComboBox;
class		KCadSaverConfig: public QDialog {
Q_OBJECT
public:

		KCadSaverConfig( QWidget *parent = NULL, const char *name = NULL );
		~KCadSaverConfig();
protected:
	void		readSettings();

private slots:
	void		setView(int i);void x();
	void		slotOkPressed();
private:
	KCadSaver	*kcadSaver;bool b;
	int		saverView;
	QComboBox	*view;

};

#endif
